local battle_loaded = false
local cooldown_pillar = TICRATE * 5/2
local cooldown_dive = TICRATE
local cooldown_interrupt = TICRATE
local spread = ANGLE_22h
local pillarthrust = 20*FRACUNIT
local spawntime = TICRATE*2
local pillarduration = TICRATE

addHook("MobjSpawn", function(mo)
	mo.flags2 = $ | MF2_SPLAT
end, MT_PYROSPAWNER)

local dopillar = function(mo)
	local pillar = P_SpawnMobjFromMobj(mo, 0, 0, P_MobjFlip(mo) * FRACUNIT, MT_PYROGEYSER)
	
	pillar.target = mo.target
	pillar.color = mo.color
	pillar.hit_sound = sfx_s3k70
	
	if P_RandomKey(2)
		pillar.renderflags = $ | RF_HORIZONTALFLIP
	end
	
	S_StartSoundAtVolume(pillar, sfx_s3k4e, 120)
	S_StartSound(pillar, sfx_blzgsr)
	
	S_StopSoundByID(mo, sfx_s3kc2l)
	P_KillMobj(mo, nil, nil)
end
local dopillars = function(player)
	for i = 1, 4
		if player.blazepillars[i] and player.blazepillars[i].valid
			dopillar(player.blazepillars[i])
		end
	end
end

addHook("MobjThinker", function(mo)
	mo.timer = $ + 1
	
	if not P_IsObjectOnGround(mo)
		mo.momx = FixedMul($, mo.friction)
		mo.momy = FixedMul($, mo.friction)
		mo.momz = FixedMul($, mo.friction)
	end
		
	if mo.target and mo.target.player and mo.target.player.thinkmoveangle
		P_Thrust(mo, mo.target.player.thinkmoveangle, pillarthrust / 30)
	else
		P_Thrust(mo, mo.angle, pillarthrust / 20)
	end
	
	if CBW_Battle
		local fire = P_SpawnMobjFromMobj(mo, P_RandomRange(-16, 16) * FRACUNIT, P_RandomRange(-16, 16) * FRACUNIT, 0, MT_FLAMEPARTICLE)
		fire.color = mo.color
		fire.colorized = true
		CBW_Battle.ZLaunch(fire, P_RandomRange(10, 20)*FRACUNIT/10, false)
	end
	
	if mo.timer > spawntime + 20 or (mo.target and mo.target.player and (not mo.target.player.actionstate or mo.target.player.actionstate < 3 or mo.target.player.playerstate != PST_LIVE or P_PlayerInPain(mo.target.player)))
		P_RemoveMobj(mo)
	end
end, MT_PYROSPAWNER)

addHook("MobjThinker", function(mo)
	if mo.frame & FF_FRAMEMASK == A + 32
		mo.flags = $ & ~MF_MISSILE
	end
end, MT_PYROGEYSER)

addHook("ThinkFrame", function()
	if battle_loaded or not CBW_Battle
		return
	end
	battle_loaded = true
	local B = CBW_Battle
	
	local BlazeSpecial = function(mo, doaction)
		local player = mo.player
		
		player.actionrings = 10
		if player.actionstate >= 3
			player.actiontext = "Detonate"
			player.actionrings = 0
		elseif P_IsObjectOnGround(mo)
			player.actiontext = "Pyro Geyser"
		else
			player.actiontext = "Burst Dive"
		end
		player.action2text = nil
		
		if P_PlayerInPain(player) or player.powers[pw_nocontrol]
		or not CBW_Battle.CanDoAction(player)
		or (player.actionstate != 3 and player.actionstate != 4 and player.blazepillars)
			if player.actionstate == 1
				B.ApplyCooldown(player,cooldown_interrupt)
			end
			if player.blazepillars
				B.ApplyCooldown(player,cooldown_pillar)
				player.blazepillars = nil
			end
			player.actionstate = 0
			player.actiontime = 0
			return
		end
		if player.actionstate == 2 and P_IsObjectOnGround(mo)
			if player == displayplayer or player == secondarydisplayplayer
				P_StartQuake(32*FRACUNIT, 7)
			end
			S_StartSound(mo, sfx_kc40)
			S_StartSound(mo, sfx_s3k70)
			
			local water = B.WaterFactor(mo)
			local blastspeed = 4
			local fuse = 12
			
			//Create projectile blast
			for n = 0, 23
				local p = P_SpawnMobjFromMobj(mo,0,0,0,MT_GROUNDPOUND)
				if p and p.valid then
					p.angle = mo.angle+n*ANG15,0
					P_InstaThrust(p, p.angle, FixedMul(p.info.speed, p.scale))
					p.target = mo
					
					p.momz = mo.scale*P_MobjFlip(mo)*blastspeed/water
					p.fuse = fuse
					
					//Hacks lol
					p.state = S_BLAZEJUMPFIRE
					p.color = player.blazeflamecolor
					
					p.hit_sound = sfx_hit01
					p.block_sound = sfx_s3k47
				end
			end
		
			player.actionstate = 0
			player.actiontime = 0
		end
		
		//Chargeup period
		if player.actionstate == 1
			player.actiontime = $ + 1
			
			//Dive launch
			if player.actiontime == 15
				B.ApplyCooldown(player,cooldown_dive)
				S_StartSound(mo, sfx_blzdiv)
				S_StartSoundAtVolume(mo, sfx_s3k4e, 120)
				
				player.actionstate = 2
				player.actiontime = 0
				player.pflags = $ & ~PF_NOJUMPDAMAGE | PF_JUMPED
				
				mo.state = S_PLAY_JUMP
				mo.blazejumping = 10
				//B.ResetPlayerProperties(player, true, true)
				P_InstaThrust(mo, mo.angle, 48*FRACUNIT)
				CBW_Battle.ZLaunch(mo, -22*FRACUNIT, false)
				if player == displayplayer or player == secondarydisplayplayer
					P_StartQuake(18*FRACUNIT, 7)
				end
			
			//Dive charging
			else
				mo.momz = 0
				player.drawangle = mo.angle
				local speed = FixedHypot(mo.momx,mo.momy)
				if speed > mo.scale then
					local dir = R_PointToAngle2(0,0,mo.momx,mo.momy)
					P_InstaThrust(mo,dir,FixedMul(speed,mo.friction))
				end
				if mo.state != S_PLAY_BLAZE_SPINDASH
					mo.state = S_PLAY_BLAZE_SPINDASH
				end
			end
			return
		end
		//Dive travel
		if player.actionstate == 2
			player.actiontime = $ + 1
			
			if (mo.momz * P_MobjFlip(mo)) <= 0
				mo.blazejumping = 10
				mo.state = S_PLAY_JUMP
				player.pflags = ($ | PF_JUMPED | PF_THOKKED)
				CBW_Battle.ZLaunch(mo, -20*FRACUNIT, false)
				local g = P_SpawnGhostMobj(mo)
				g.destscale = $ * 2
				g.blendmode = AST_ADD
				g.colorized = true
				g.color = skins[mo.skin].prefcolor
				g.frame = ($ & ~FF_TRANSMASK) | TR_TRANS90
			else
				mo.blazejumping = 0
				player.actionstate = 0
				player.actiontime = 0
				B.ResetPlayerProperties(player, false, true)
				mo.state = S_PLAY_SPRING
			end
			return
		end
		//Pillar spawn twirl
		if player.actionstate == 3
			player.pflags = $ | PF_JUMPED
			mo.state = S_PLAY_ROLL
			mo.frame = (player.actiontime) % 4
			if player.actiontime >= 4
				mo.frame = (player.actiontime/2 + 2) % 4
			end
			
			player.actiontime = $ + 1
			if player.actiontime >= 10
				player.pflags = $ & ~PF_JUMPED
				player.actionstate = 4
				player.actiontime = 0
				mo.state = S_PLAY_WALK
				player.pflags = $ & ~PF_SPINNING
			end
			return
		end
		
		if player.actionstate == 4 and player.blazepillars
			player.actiontime = $ + 1
			if (doaction == 1 and player.actiontime > 5) or player.actiontime >= spawntime
				dopillars(player)
				S_StartSoundAtVolume(nil, sfx_s3k9c, 100, player)
				P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_SUPERSPARK)
				local g = P_SpawnGhostMobj(mo)
				g.destscale = $ * 2
				g.blendmode = AST_ADD
				g.colorized = true
				g.color = SKINCOLOR_WHITE
				B.ApplyCooldown(player,cooldown_pillar)
				player.actionstate = 0
				player.actiontime = 0
				player.blazepillars = nil
			end
			return
		end
		
		//Activating the special move
		if doaction != 1
			return
		end
		
		B.PayRings(player)
		
		//Ground special
		if P_IsObjectOnGround(mo)
			S_StartSound(mo, sfx_s3k70)
			
			player.actionstate = 3
			player.pflags = $ | PF_JUMPED
			mo.state = S_PLAY_JUMP
			
			local g = P_SpawnGhostMobj(mo)
			g.color = SKINCOLOR_YELLOW
			g.colorized = true
			g.destscale = g.scale * 2
			
			local angles = {-spread * 3, -spread, spread, spread * 3}
			player.blazepillars = {}
			
			for i = 1, 4
				local disc = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_PYROSPAWNER)
				player.blazepillars[i] = disc
				disc.target = mo
				disc.angle = mo.angle
				disc.color = player.blazeflamecolor
				disc.timer = 0
				P_Thrust(disc, mo.angle + angles[i], pillarthrust)
				P_Thrust(disc, mo.angle, player.speed)
				S_StartSoundAtVolume(disc, sfx_s3kc2l, 80)
			end
			
			mo.momx = $ / 2
			mo.momy = $ / 2
			
		//Air special
		else
			S_StartSound(mo, sfx_blzrev)
			mo.state = S_PLAY_BLAZE_SPINDASH
			player.pflags = $ | PF_JUMPSTASIS & ~PF_JUMPED & ~PF_SHIELDABILITY & ~PF_SPINNING
			
			player.blazehover = false
			player.blazehoverpower = 0
			player.blazehovertimer = 0
			player.mo.blazejumping = 0
			
			player.actionstate = 1
			player.actiontime = 0
		end
	end
	
	local BlazePriority = function(player)
		local mo = player.mo
		local spinjump = (player.pflags&PF_JUMPED and not(player.pflags&PF_NOJUMPDAMAGE))
		local spinning = (mo.state == S_PLAY_BLAZE_SPIN) or (mo.state == S_PLAY_ROLL)
		if player.blazeboosting
			B.SetPriority(player,3,1,nil,3,1,"flame boost")
		elseif player.actionstate == 1
			B.SetPriority(player,0,0,nil,0,0,"burst dive charge")
		elseif player.actionstate == 2
			B.SetPriority(player,2,2,nil,2,2,"burst dive")
		elseif player.actionstate == 3 or (spinning and not spinjump)
			B.SetPriority(player,1,1,nil,1,1,"axel spin")
		elseif mo.blazejumping
			B.SetPriority(player,1,2,nil,1,2,"accelerator tornado")
		elseif spinjump
			B.SetPriority(player,1,1,nil,1,1,"axel jump")
		end
	end
	
	B.SkinVars["blaze"] = {
		weight = 95,
		special = BlazeSpecial,
		func_priority = BlazePriority
	}
	
	print("\x89\Blaze's BattleMod support has been added!")
end)
